#include <iostream>
#include <fstream>
#include <iomanip>
#include "CalendaristicData.h"

using namespace std;

void setFlag(){
	ofstream os;
	os.setstate(ios::failbit);
}

void checkTheFlag(){
	ofstream os;
	if (os.good()){
		//use os
	}
}

void resetFlags(){
	ofstream os;
	os.setstate(ios::failbit);
	os.clear();
	bool b = os.good();		//b = true
}

void dataProcessing(){
	CalendaristicData data;
	cin >> data;
	if (cin.fail())
		cout << "data was not read..." << endl;
	if (cin.good())
		cout << "data " << data << " was correctly read..." << endl;
	
}

void getExample(){
	//char* s1 = new char[100];
	//cin >> s1;
	//cout << s1;
	//delete[] s1;

	
	char c = cin.get(); //extract the first character from the stream cin
	cout << " c = " << c <<endl;

	char nextCharFromStream = cin.get();	//read the ENTER or the remains elements

	int MAX = 5;
	char* s2 = new char[MAX];
	cin.get(s2, MAX);	//read in s2 maximum MAX elements
	cout << "s2 = " << s2 << endl;

	nextCharFromStream = cin.get();	//read the ENTER
	cout << "cEnter = " << nextCharFromStream << endl;

	char* s3 = new char[MAX];
	char delim = ';';
	cin.get(s3, MAX, delim);	//read in s3 maximum MAX elements until the first delimitator; delim rests in the cin stream
	cout << "s3 = " << s3 << endl;

	char cDelim = cin.get();
	cout << "cDelim = " << cDelim << endl;
}

void getlineExample(){
	//char* s1 = new char[100];
	//cin >> s1;
	//cout << s1;
	//delete[] s1;

	int MAX = 5;
	char* s2 = new char[MAX];
	cin.getline(s2, MAX);	//read in s2 maximum MAX elements
	cout << "s2 = " << s2 << endl;

	char nextCharFromStream = cin.get();	//read the ENTER
	cout << "cEnter = " << nextCharFromStream << endl;

	char* s3 = new char[MAX];
	char delim = ';';
	cin.getline(s3, MAX, delim);	//read in s3 maximum MAX elements until the first delimitator; delim rests in the cin stream
	cout << "s3 = " << s3 << endl;

	char cDelim = cin.get();
	cout << "cDelim = " << cDelim << endl;
}




void iofstreamExample(){
	char* fileNameIn = "data.in";
	ifstream ifs;	//variable of type input file
	ifs.open(fileNameIn);
	if (!ifs.fail()){	//ifs._FileBuufer._Myfile._flag == 1
		while(!ifs.eof()){
			char elem;
			ifs >> elem;
			cout << "elem = " << elem << endl;
		}
		ifs.close();	//the file is implicit closed by the destructor of the stream, but only to the end of scope
	}
	char* fileNameOut = "data.out";
	ofstream ofs;
	ofs.open(fileNameOut);
	for(int i = 0; i < 10; i++)
		ofs << i << " ";
	ofs.close();
}

void streamBuffering(){
	ifstream ifs;
	ifs.open("data.in");
	if (!ifs.fail()){
		streampos pos = ifs.tellg();
		cout << ifs.rdbuf() << endl;	//print the entire content of the file
		
		ofstream ofs;
		ofs.open("copyOfData.out");
		ifs.seekg(pos);
		ofs << ifs.rdbuf();
		ofs.close();
		ifs.close();
	}
}

void formatFlags(){
	cout.setf(ios::showpos);
	cout << 3 << endl;	//=> +3
	cout.unsetf(ios::showpos);
	cout << 3 << endl;	//=> 3

	cout.setf(ios::dec);
	cout << 10 << endl;	//=>10
	cout.setf(ios::hex);
	cout << 10 << endl;	//=>A
}

void manipulators(){
	ofstream ofs;
	ofs.open("manipEx.out");
	int i = 13;
	float f = 3.1415926535;
	char* s = "this is a white flower";
	ofs << setiosflags(ios::unitbuf|ios::showbase|ios::uppercase|ios::showpos);
	ofs << i << endl;	//=>+13
	ofs << hex << i << endl;	//=>0xD
	ofs << resetiosflags(ios::uppercase);
	ofs << hex << i << endl;	//=> 0xd
	ofs << "fill char " << ofs.fail() << endl;	//=> fill char 0
	ofs << internal << setw(10) << dec << i << endl;	//=> +       13
	ofs << i << endl;	//=>+13
	ofs.close();
}

void standardIO(){
	int x; 	float y;	char c;	char t[20];
	scanf("%d %f %c %s", &x, &y, &c, t);
	char mounth[10];	int day;
	sscanf("May 10", "%s%d", &mounth, &day);

	int i = 26;	
	printf("%d %o %x %X\n", i, i, i, i);	//=> 26 32 1a 1A
	float pi = 3.1415926535;
	printf("%f %7.2f %7.2e\n", pi, pi, pi);	//=> 3.141593 3.14 3.14e+000
	printf("%.*f \n", 3, pi);	//=>3.142
	char s[] = "abcdefghij";
	printf("%s %.5s \n", s, s);	//=> abcdefghij abcde
	printf("%.*s \n", 3, s);	//=> abc

	char text[11];
	sprintf(text, "%d+%d", 2, 5);
	printf("%s \n", text);

}

void getPut(){
	
	
	char c;
	while ((c = getchar()) != EOF){
		putchar(c);
	}
	while ((c = getc(stdin)) != EOF){
		putc(c, stdout);
	}

	char s[20];
	while (gets(s) != NULL)	//s could have max 19 characters
		puts(s);

}
void standardFileIO(){
	FILE *ifp;
	ifp = fopen("data.in", "r");
	FILE *ofp;
	ofp = fopen("dataFIO.out", "w");
	char c;
	while ((c = fgetc(ifp)) != EOF)
		fputc(c, ofp);
	//while ((c = getc(ifp)) != EOF)
	//	putc(c, ofp);
	
	char s[100];
	//while (fgets(s, 100, ifp) != NULL)
	//	fputs(s, ofp);

	//while (fscanf(ifp, "%s", s) > 0)
	//	fprintf(ofp, "%s \n", s);

	fclose(ofp);
	fclose(ifp);

	FILE *bifp = fopen("data.in", "rb");
	FILE *bofp = fopen("dataBFIO.out", "wb");
	while (fread(s, sizeof(char), 100, bifp) > 0)
		fwrite(s, sizeof(char), 100, bofp);
	fclose(bofp);
	fclose(bifp);

}

int main(){

	standardIO();
	//getPut();
	//standardFileIO();

	//setFlag();
	//checkTheFlag();
	//resetFlags();
	//dataProcessing();
	//getExample();
	//getlineExample();

	//iofstreamExample();
	//streamBuffering();

	//formatFlags();
	//manipulators();


	return 0;
}